/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   process_frame.h
 * Author: ilia
 *
 * Created on 27 сентября 2017 г., 14:45
 */

#ifndef PROCESS_FRAME_H
#define PROCESS_FRAME_H

#include "translate_info.h"
#include "resampled.h"
#include "warn_config.h"

struct process_frame_args
{
    resampled_array_t warns;
    struct warn_config cfg;
};

struct process_frame_info
{
    struct translator_info_list translators;    // only bridge_simple
    struct resampled_data *rs_last;             // only bridge_simple    
    unsigned int samples_offset;
};

int process_frame_init(struct process_frame_args *args);

void process_frame_deinit(struct process_frame_args *args);

struct ast_frame *process_frame(struct ast_bridge_channel *bridge_channel,
    struct process_frame_args *args, struct ast_frame *frame, int update_offset);

int process_frame_add_channel(struct ast_bridge_channel *bridge_channel,
    struct process_frame_args *args);

void process_frame_remove_channel(struct ast_bridge_channel *bridge_channel,
    struct process_frame_args *args);

void process_frame_slin(struct process_frame_args *args,
    struct process_frame_info *info, struct resampled_data *rs,
    struct ast_frame *frame, int update_offset);

void process_frame_update_offset(struct process_frame_args *args,
    struct process_frame_info *info, struct resampled_data *rs,
    struct ast_frame *frame);

void process_frame_update_rate(struct resampled_data *rs_new,
    struct resampled_data *rs_old, unsigned int *samples_offset);

#endif /* PROCESS_FRAME_H */
