/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   translate_info.h
 * Author: ilia
 *
 * Created on 28 сентября 2017 г., 16:39
 */

#ifndef TRANSLATE_INFO_H
#define TRANSLATE_INFO_H

#include "config.h"
#include "resampled.h"

#include "asterisk/linkedlists.h"
#include "asterisk/channel.h"
#include "asterisk/translate.h"
#include "asterisk/format.h"

struct translator_info
{
    AST_LIST_ENTRY(translator_info) entry;

#if AST_VER >= 120000 && AST_VER < 130000
    struct ast_format format;
#else
    struct ast_format *format;
#endif
    struct resampled_data *rs;

    struct ast_trans_pvt *to_slinear;
    struct ast_trans_pvt *from_slinear;
};

AST_LIST_HEAD(translator_info_list, translator_info);


void translator_info_free(struct translator_info *info);

struct translator_info *translator_info_new(resampled_array_t arr,
    struct ast_format *format);

int translator_info_update(struct translator_info *info,
    struct ast_channel *channel, struct ast_format *format);

void translator_info_list_init(struct translator_info_list *translator_info_list);

void translator_info_list_free(struct translator_info_list *translator_info_list);

struct translator_info *translator_info_list_get(
    struct translator_info_list *translator_info_list,
    const struct ast_format *format);

void translator_info_list_add(struct translator_info_list *translator_info_list,
    struct translator_info *translator_info);


#endif /* TRANSLATE_INFO_H */

